#include <iostream>
#include <vector>

using namespace std;

const size_t SCREEN_WIDTH = 80;
const size_t MAX_ASTERISK = SCREEN_WIDTH - 3 - 1;

void indent(int number)
{
    if (number < 10)
    {
        cout << "  ";
    }
    else if (number < 100)
    {
        cout << " ";
    }
    else
    {
        cout << "";
    }
}

int main()
{
    size_t number_count;
    cerr << "Enter number count: ";
    cin >> number_count;

    vector<double> numbers(number_count);

    for (size_t i = 0; i < number_count; i++)
    {
        cerr << "Enter numbers: ";
        cin >> numbers[i];
    }

    size_t bin_count;
    cerr << "Enter bin count: ";
    cin >> bin_count;

    vector<size_t> bins(bin_count);

    double min = numbers[0];
    double max = numbers[0];

    for (double x : numbers)
    {
        if (x < min)
        {
            min = x;
        }
        else if (x > max)
        {
            max = x;
        }
    }

    size_t max_count = 0;
    double bin_size = (max - min) / bin_count;

    for (size_t i = 0; i < number_count; i++)
    {
        bool found = false;
        for (size_t j = 0; (j < bin_count - 1) && !found; j++)
        {
            auto lo = min + j * bin_size;
            auto hi = min + (j + 1) * bin_size;
            if ((lo <= numbers[i]) && (numbers[i] < hi))
            {
                bins[j]++;
                if (bins[j] > max_count)
                {
                    max_count = bins[j];
                }
                found = true;
            }
        }
        if (!found)
        {
            bins[bin_count - 1]++;
            if (bins[bin_count - 1] > max_count)
            {
                max_count = bins[bin_count - 1];
            }
        }
    }

    if (max_count <= 76)
    {
        for (size_t i = 0; i < bin_count; i++)
        {
            indent(bins[i]);
            cout << bins[i] << "|";
            for (size_t j = 0; j < bins[i]; j++)
            {
                cout << "*";
            }
            cout << endl;
        }
    }

    else
    {
        for (size_t i = 0; i < bin_count; i++)
        {
            size_t height = 76 * (static_cast<double>(bins[i]) / max_count);
            indent(bins[i]);
            cout << bins[i] << "|";
            for (size_t j = 0; j < height; j++)
            {
                cout << "*";
            }
            cout << endl;
        }
    }
    return 0;

}
